#include "utils.h"
#include "bndfile.h"
#include "getopts.h"

static void LogCNI(const ChrNameIndex &CNI)
	{
	Dump("    Pos    Index            Chromosome\n");
	Dump("=======  =======  ====================\n");
	const unsigned ChrCount = CNI.GetChrCount();
	unsigned ChrIndex = UINT_MAX;
	for (unsigned i = 0; i < ChrCount; ++i)
		{
		if (i == 0)
			ChrIndex = CNI.GetFirstChrIndex();
		else
			ChrIndex = CNI.GetNextChrIndex(ChrIndex);

		const char *ChrName = CNI.GetName(ChrIndex);

		Dump("%7u  %7u  %20.20s\n", i, ChrIndex, ChrName);
		}
	}

void DumpBndCNI()
	{
	const char *FileName = RequiredValueOpt("dumpbndcni");

	BndFile Bnd;
	Bnd.Open(FileName);
	
	const ChrNameIndex &CNIA = Bnd.GetChrNameIndex1();
	const ChrNameIndex &CNIB = Bnd.GetChrNameIndex2();

	Dump("Genome A (%s):\n", Bnd.GetGenomeName1());
	LogCNI(CNIA);

	Dump("\n\n");
	Dump("Genome B (%s):\n", Bnd.GetGenomeName2());
	LogCNI(CNIB);
	}
