#include "utils.h"
#include "revfile.h"

// TODO: ALMOST IDENTICAL TO getbps.cpp, SHOULD CONSOLIDATE

static coord_t AddMargin(coord_t Pos, unsigned Margin)
	{
	return Pos + Margin;
	}

static coord_t SubMargin(coord_t Pos, unsigned Margin)
	{
	if (Pos >= Margin)
		return Pos - Margin;
	return 0;
	}

//static bool LT(const AIBP &BP1, const AIBP &BP2)
//	{
//	if (BP1.SegIndex != BP2.SegIndex)
//		return BP1.SegIndex < BP2.SegIndex;
//
//	if (BP1.Pos != BP2.Pos)
//		return BP1.Pos < BP2.Pos;
//
//// Same pos
//// Sort lo's before hi's
//	return BP1.IsLo && !BP2.IsLo;
//	}

void GetBendpoints(const std::vector<AlnInfoX> &AIXs, unsigned GenomeIndex,
  unsigned ChrId, std::vector<AIBP> &BPs, unsigned Margin, bool Subscript)
	{
	const unsigned AICount = (unsigned) AIXs.size();

	BPs.clear();
	BPs.reserve(2*AICount);

	for (unsigned i = 0; i < AICount; ++i)
		{
		const AlnInfoX &AIX = AIXs[i];
		const AlnInfo &AI = AIX.AI;

	// Note: a given genome index may occur more than once
		const unsigned SegCount = (unsigned) AI.Segs.size();
		for (unsigned SegIndex = 0; SegIndex < SegCount; ++SegIndex)
			{
			const GCSeg &Seg = AI.Segs[SegIndex];

			if (Seg.GenomeIndex != GenomeIndex)
				continue;
			if (Seg.ChrId != ChrId)
				continue;

			coord_t OldLo = Seg.lo;
			coord_t OldHi = Seg.hi;
			coord_t NewLo = AddMargin(OldLo, Margin);
			coord_t NewHi = SubMargin(OldHi, Margin);

			if (NewLo > NewHi)
				{
				coord_t Mid = (OldHi + OldLo)/2;
				NewLo = Mid;
				NewHi = Mid;
				}

			AIBP BP;
			if (Subscript)
				BP.AlnInfoIndex = i;
			else
				BP.AlnInfoIndex = AIX.AlnInfoIndex;

			BP.ChrId = Seg.ChrId;
			BP.SegIndex = SegIndex;

			BP.Pos = NewLo;
			BP.IsLo = true;
			BPs.push_back(BP);

			BP.Pos = NewHi;
			BP.IsLo = false;
			BPs.push_back(BP);
			}
		}

//	std::sort(BPs.begin(), BPs.end(), LT);
	std::sort(BPs.begin(), BPs.end());
	}
