#include "utils.h"
#include "icevo.h"

void InterChrEvolver::GetRandomPos(unsigned &ChrIndex, gpos_t &Length) const
	{
	}

void InterChrEvolver::GetRandomPosDifferentChr(unsigned ChrIndex,
  unsigned &ChrIndex2, gpos_t &Pos2) const
	{
	}

bool InterChrEvolver::AcceptInsert(unsigned ChrIndex, gpos_t Pos, gpos_t Length) const
	{
	return true;
	}

bool InterChrEvolver::AcceptMove(unsigned ChrIndex, gpos_t Pos, gpos_t Length) const
	{
	return true;
	}

gpos_t InterChrEvolver::GetLength() const
	{
	gpos_t Length = 0;
	const unsigned ChrCount = SIZE(m_Chrs);
	for (unsigned ChrIndex = 0; ChrIndex < ChrCount; ++ChrIndex)
		{
		const list<AncContig> &Chr = m_Chrs[ChrIndex];
		for (list<AncContig>::const_iterator p = Chr.begin(); p != Chr.end(); ++p)
			{
			const AncContig &AC = *p;
			Length += AC.Length;
			}
		}
	return Length;
	}

void InterChrEvolver::GetACs(unsigned ChrIndex, gpos_t Pos, gpos_t Length,
  vector<AncContig> &ACs) const
	{
	ACs.clear();
	if (ChrIndex >= SIZE(m_Chrs))
		Die("GetACs: invalid chr");
	if (Length == 0)
		return;
	const list<AncContig> &Chr = m_Chrs[ChrIndex];
	asserta(SIZE(Chr) > 0);
	gpos_t LengthRemaining = Length;
	for (list<AncContig>::const_iterator p = Chr.begin(); p != Chr.end(); ++p)
		{
		const AncContig &ChrAC = *p;
		gpos_t ChrACEndPos = ChrAC.Pos + ChrAC.Length - 1;
		if (ChrACEndPos < Pos)
			continue;

		AncContig AC;
		if (ChrAC.Pos < Pos)
			AC.Pos = Pos;
		else
			AC.Pos = ChrAC.Pos;
		gpos_t ACEndPos = AC.Pos + LengthRemaining - 1;
		if (ACEndPos > ChrACEndPos)
			ACEndPos = ChrACEndPos;
		AC.Length = ACEndPos - AC.Pos + 1;
		ACs.push_back(AC);
		asserta(LengthRemaining >= AC.Length);
		LengthRemaining -= AC.Length;
		if (LengthRemaining == 0)
			return;
		}
	Die("GetACs, range overflows chr");
	}
