#include "bndfile.h"
#include "utils.h"

void LogSeg(const Seg &s)
	{
	Log("%u %u", s.lo, s.hi);
	}

void LogSP(const SegPair &SP)
	{
	Log("%u %u %u %u %c",
	  SP.Segs[0].lo,
	  SP.Segs[0].hi,
	  SP.Segs[1].lo,
	  SP.Segs[1].hi,
	  SP.Reverse ? '-' : '+');
	}

void LogSPN(const SegPair &SP)
	{
	LogSP(SP);
	Log("\n");
	}

void LogSPs(const SPVec &SPs)
	{
	const unsigned SPCount = (unsigned) SPs.size();
	for (unsigned i = 0; i < SPCount; ++i)
		LogSPN(*(SPs[i]));
	}
