#include "mus.h"

DPMemData g_DPMem;

static ScoreMx g_SubstMx;
static vector<string> *g_ptrLabels;
static vector<string> *g_ptrSeqs;
static void OnSeq(const string &Label, const string &Seq)
	{
	g_ptrLabels->push_back(Label);
	g_ptrSeqs->push_back(Seq);
	}

void OnGroupLabel(const string &Label)
	{
	Progress("%s", Label.c_str());
	}

void ReadMFA(const char *FileName, vector<string> &Labels, vector<string> &Seqs)
	{
	Labels.clear();
	Seqs.clear();

	g_ptrLabels = &Labels;
	g_ptrSeqs = &Seqs;

	ReadFasta(FileName, OnSeq, OnGroupLabel);
	}

static double DoPair(const string &LabelA, const string &LabelB,
  const string &GA, const string &GB, 
  const string &UA, const string &UB,
  const vector<byte> &/*GVA*/, const vector<byte> &/*GVB*/,
  const vector<byte> &UVA, const vector<byte> &UVB,
  const ParamVec &Params)
	{
	g_DPMem.Alloc(SIZE(GA), SIZE(GB), 4, 3);

	string Path;
	SCORE Score = NW(UVA, UVB, Params, false, Path);

	vector<string> RefMSA;
	RefMSA.push_back(GA);
	RefMSA.push_back(GB);

	vector<string> TestMSA(2);
	AlnStr(UA, Path, true, TestMSA[0]);
	AlnStr(UB, Path, false, TestMSA[1]);

	vector<string> Labels;
	Labels.push_back(LabelA);
	Labels.push_back(LabelB);

	Log("\n");
	Log("%s\n", TestMSA[0].c_str());
	Log("%s\n", TestMSA[1].c_str());
	Log("%s\n", Path.c_str());

	double Q;
	double TC;
	QScore("?", TestMSA, Labels, RefMSA, Labels, Q, TC, false);
	Log("%s,%s score=%.3g Q=%5.3f TC=%5.3f\n",
	  LabelA.c_str(), LabelB.c_str(), Score, Q, TC);

	return Q;
	}

void Test()
	{
//	g_SubstMx = GetSubstMx();
//	unsigned AlphabetSize = GetAlphabetSize();
//
//	AllocScoreMx(AlphabetSize, AlphabetSize, g_SubstMx);
//	ReadSubstMx("BLOSUM62", g_SubstMx);
////	LogSubstMx(g_SubstMx);
//
//	ParamVec Params;
//	Params.Set(P_g, 12);
//	Params.Set(P_e, 2);
//	Params.Set(P_tg, 1);
//	Params.Set(P_te, 1);
//	Params.Set(P_mf, 1);
//
	vector<string> Labels;
	vector<string> GappedSeqs;
	ReadMFA("bali2.fa", Labels, GappedSeqs);

	//uns N = SIZE(GappedSeqs);
	//if (N == 0 || N%2 != 0)
	//	Die("Need x2 seqs");

	//vector<string> UngappedSeqs;
	//vector<vector<byte> > GappedBVs;
	//vector<vector<byte> > UngappedBVs;
	//SeqsToByteVecs(GappedSeqs, UngappedSeqs, GappedBVs, UngappedBVs);

	//double SumQ = 0;
	//for (uns i = 0; i < N; i += 2)
	//	{
	//	const string &GA = GappedSeqs[i];
	//	const string &GB = GappedSeqs[i+1];

	//	const string &UA = UngappedSeqs[i];
	//	const string &UB = UngappedSeqs[i+1];

	//	const vector<byte> &GVA = GappedBVs[i];
	//	const vector<byte> &GVB = GappedBVs[i+1];

	//	const vector<byte> &UVA = UngappedBVs[i];
	//	const vector<byte> &UVB = UngappedBVs[i+1];

	//	const string &LabelA = Labels[i];
	//	const string &LabelB = Labels[i+1];
	//	SumQ += DoPair(LabelA, LabelB, GA, GB, UA, UB, GVA, GVB, UVA, UVB, Params);
	//	}
	//Log("\n");
	//Log("Q=%5.3f\n", 2.0*SumQ/N);
	}
