#ifndef MYSTDIO_H
#define MYSTDIO_H

#include "types.h"

#ifdef _MSC_VER
#define ftello ftell
#define fseeko fseek
typedef long off_t;
#endif

FILE *OpenStdioFile(const char *FileName, bool ForWriting = false);
FILE *OpenStdioFileRW(const char *FileName);
FILE *CreateStdioFile(const char *FileName);
void SeekStdioFile(FILE *f, off_t Pos);

void ReadStdioFile(FILE *f, off_t Pos, void *Buffer, off_t Bytes);
void ReadStdioFile(FILE *f, void *Buffer, off_t Bytes);
bool ReadLineStdioFile(FILE *f, char *Line, off_t Bytes);
void ReadLineStdioFile2(FILE *f, char *Line, off_t Bytes);

void WriteStdioFile(FILE *f, off_t Pos, const void *Buffer, off_t Bytes);
void WriteStdioFile(FILE *f, const void *Buffer, off_t Bytes);
void WriteStdioFileStr(FILE *f, off_t Pos, const char *Buffer);
void WriteStdioFileStr(FILE *f, const char *Buffer);

off_t GetStdioFilePos(FILE *f);
void CloseStdioFile(FILE *f);
off_t GetStdioFileSize(FILE *f);

void DeleteStdioFile(const char *FileName);

bool FileExists(const char *FileName);

void TraceStdioOpens(bool On);

#endif	// MYSTDIO_H
