#include "revfile.h"
#include "bndfile.h"

extern unsigned g_ChrIndex1;
extern unsigned g_ChrIndex2;

void SPToAI(const SegPair &SP, AlnInfo &AI)
	{
	AI.Segs.resize(2);

	GCSeg &SA = AI.Segs[0];
	GCSeg &SB = AI.Segs[1];

	SA.GenomeIndex = 0;
	SB.GenomeIndex = 1;

	SA.ChrId = g_ChrIndex1;
	SB.ChrId = g_ChrIndex2;

	SA.lo = SP.Segs[0].lo;
	SB.lo = SP.Segs[1].lo;

	SA.hi = SP.Segs[0].hi;
	SB.hi = SP.Segs[1].hi;

	SA.Plus = false;
	SB.Plus = !SP.Reverse;

	AI.Score = (ai_score_t) SP.Score;

	AI.Attrs.clear();
	AI.Values.clear();

	if (SP.AlnLength != 0)
		AI.SetAlnLength(SP.AlnLength);
	}

void AIToSP(const AlnInfo &AI, SegPair &SP)
	{
	if (AI.Segs.size() != 2)
		Die("AIToSP must be pairwise");

	const GCSeg &SA = AI.Segs[0];
	const GCSeg &SB = AI.Segs[1];

	SP.Segs[0].lo = SA.lo;
	SP.Segs[1].lo = SB.lo;

	SP.Segs[0].hi = SA.hi;
	SP.Segs[1].hi = SB.hi;

	SP.Score = (sp_score_t) AI.Score;
	SP.AlnLength = AI.GetAlnLength();

	if (SA.Plus != SB.Plus)
		SP.Reverse = true;
	else
		SP.Reverse = false;
	}
