#include "stack.h"

#define TRACE	0

bool Stacker::ValidateNoOutputOverlaps()
	{
	const unsigned GenCount = ptrIn->GetGenomeCount();
	for (unsigned GenIndex = 0; GenIndex < GenCount; ++GenIndex)
		{
		bool OK = ValidateNoOutputOverlapsGenome(GenIndex);
		if (!OK)
			return false;
		}
	return true;
	}

bool Stacker::ValidateNoOutputOverlapsGenome(unsigned GenIndex)
	{
	AIBPVec BPs;
	GetBendpoints(OutputAIs, GenIndex, BPs, 0);
	const unsigned BPCount = (unsigned) BPs.size();

#if	TRACE
	Log("\n");
	Log(" CopyCount     LastPos  lh         Pos    ChrId\n");
	Log("==========  ==========  ==  ==========  =======\n");
#endif

	AIBP LastBP;
	LastBP.ChrId = UINT_MAX;
	LastBP.Pos = 0;
	for (unsigned BPIndex = 0; BPIndex < BPCount; ++BPIndex)
		{
		const AIBP &BP = BPs[BPIndex];
		if (BP.ChrId == LastBP.ChrId && BP.Pos <= LastBP.Pos && BP.AlnInfoIndex
		  != LastBP.AlnInfoIndex)
			{
			Log("\n");
			Log("OutputBPs:\n");
			LogAIBPs(BPs);
			Log("\n");
			LogBP(LastBP);
			Log("\n");
			LogBP(BP);
			Log("\n");
			Warning("Overlap CCIndex %u, %u alns, %u output blocks",
			  InputCCIndex, SIZE(*ptrAIXs), (unsigned) OutputAIs.size());
			return false;
			}
		LastBP = BP;
		}
	return true;
	}
