#include "evo.h"

#define	TRACE		0
#define	SET_RAND	0
#define FILE_SIZE	100000

void TestBitFile()
	{
	unsigned char Bits = 0;
	SetBits(Bits, 0, 0x3, 3);
	asserta(Bits == 0x3);

	Bits = 0;
	SetBits(Bits, 0, 0xf, 4);
	SetBits(Bits, 4, 0xf, 4);
	asserta(Bits == 0xff);

	Bits = GetBits(Bits, 3, 2);
	asserta(Bits == 3);

	unsigned char FileData[FILE_SIZE];
	RandBuffer(FileData, sizeof(FileData));

	FILE *f1 = CreateStdioFile("bitfile1.tmp");
	WriteStdioFile(f1, FileData, sizeof(FileData));
	CloseStdioFile(f1);
	f1 = 0;

	FILE *f2 = CreateStdioFile("bitfile2.tmp");
	BitFile BF;
	BF.OpenWriting(f2);

	unsigned BytePos = 0;
	unsigned BitPos = 0;
#if	SET_RAND
	srand(123);
#endif
	for (;;)
		{
		unsigned BitCount = RandInt(8 - BitPos) + 1;
		unsigned char Bits = GetBits(FileData[BytePos], BitPos, BitCount);
		BF.AppendBits(Bits, BitCount);
#if	TRACE
		Log("Append bits %02x %u  CurrByte %02x  BytePos %3u  BitPos %u\n",
		  Bits, BitCount, FileData[BytePos], BytePos, BitPos);
#endif
		BitPos += BitCount;
		if (BitPos >= 8)
			{
			BitPos -= 8;
			++BytePos;
			}
		if (BytePos == sizeof(FileData))
			break;
		}
	BF.Close();

	unsigned char FileData2[sizeof(FileData)];
	memset(FileData2, 0, sizeof(FileData2));

	FILE *f3 = OpenStdioFile("bitfile1.tmp");
	BF.OpenReading(f3);

	BitPos = 0;
	BytePos = 0;
#if	SET_RAND
	srand(123);
#endif
	for (;;)
		{
		unsigned BitCount = RandInt(8 - BitPos) + 1;
		unsigned char Bits = BF.ReadBits(BitCount);
		SetBits(FileData2[BytePos], BitPos, Bits, BitCount);
#if	TRACE
		Log("Read bits %02x %u  CurrByte %02x  BytePos %3u  BitPos %u\n",
		  Bits, BitCount, FileData2[BytePos], BytePos, BitPos);
#endif
		BitPos += BitCount;
		if (BitPos >= 8)
			{
			BitPos -= 8;
			++BytePos;
			}
		if (BytePos == sizeof(FileData2))
			break;
		}
	BF.Close();

	FILE *f4 = CreateStdioFile("bitfile3.tmp");
	WriteStdioFile(f4, FileData2, sizeof(FileData2));
	CloseStdioFile(f4);
	f4 = 0;

	for (unsigned i = 0; i < sizeof(FileData); ++i)
		asserta(FileData[i] == FileData2[i]);

	Progress("BitFile test succeeded");

	exit(0);
	}
