#ifndef timing_h
#define timing_h

#if	defined(_MSC_VER)
#pragma warning(disable:4035)
typedef unsigned __int64 TICKS;
inline TICKS GetClockTicks()
	{
	_asm
		{
	// Intel x86 RDTSC instruction
		rdtsc

	// Earlier MSC compiler versions didn't know
	// the opcode.
	//	_emit	0x0f
	//	_emit	0x31
		}
	}

#elif	defined(__GNUC__)
#include <stdint.h>
typedef uint64_t TICKS;
__inline__ uint64_t GetClockTicks()
	{
	uint32_t lo, hi;
	__asm__ __volatile__ ("rdtsc" : "=a" (lo), "=d" (hi));
	return (uint64_t)hi << 32 | lo;
	}
#else
#error "Unsupported compiler (timing.h)"
#endif

enum TIMEROP
	{
#define T(t)	TIMEROP_##t,
#include "timerops.h"
	};

const unsigned TimerOpCount = 0 +
#define T(t)	+ 1
#include "timerops.h"
	;

void InitTiming();
void TimerDone(TIMEROP t, TICKS t1, TICKS t2);
void TimingReport();
const char *TimerOpToStr(TIMEROP t);

#define TimerStart(Op)	TICKS t1##Op##__ = GetClockTicks();
#define TimerStop(Op)	TICKS t2##Op##__ = GetClockTicks(); TimerDone(TIMEROP_##Op, t1##Op##__, t2##Op##__);

#endif // timing_h
