#include "icevo.h"
#include "ratemgr.h"

extern RateMgr *g_InterChrCopyRateMgr;

bool InterChrEvolver::Try_InterChrCopy()
	{
	gpos_t FromPos = GetRandomPos();
	if (FromPos == GPOS_T_MAX)
		return false;

	gpos_t ToPos = GetRandomPosDifferentChr(FromPos);
	if (ToPos == GPOS_T_MAX)
		return false;

	gpos_t CopyLength = g_InterChrCopyRateMgr->GetLength();

	if (!RangeExists(FromPos, CopyLength))
		return false;

	if (!RangeExists(ToPos, 2))
		return false;

	if (PosInRange(ToPos, FromPos, CopyLength))
		return false;

	bool Accept = AcceptInsert(ToPos, CopyLength);
	if (!Accept)
		return true;

	Copy(FromPos, ToPos, CopyLength);
	// GeneDupe(FromPos, CopyLength, ToPos); // TODO need to implement?
	g_InterChrCopyRateMgr->StoreResult((EVENT_RESULT) 0, CopyLength);
	return true;
	}
