#include "revfile.h"

void GetBoundRect(const AIVec &AIs, unsigned GenomeIndexA, unsigned GenomeIndexB,
  AlnInfo &Rect)
	{
	const unsigned AICount = (unsigned) AIs.size();

	if (AIs.size() == 0)
		Die("GetBoundRect: empty set");

	const AlnInfo &First = AIs[0];

	GCSeg RectSegA = First.GetSeg(GenomeIndexA);
	GCSeg RectSegB = First.GetSeg(GenomeIndexB);

	unsigned PlusCount = 0;
	unsigned MinusCount = 0;

	for (unsigned AIIndex = 0; AIIndex < AICount; ++AIIndex)
		{
		const AlnInfo &AI = AIs[AIIndex];

		const GCSeg &SegA = AI.GetSeg(GenomeIndexA);
		const GCSeg &SegB = AI.GetSeg(GenomeIndexB);

		bool Plus = (SegA.Plus == SegB.Plus);
		if (Plus)
			++PlusCount;
		else
			++MinusCount;

		if (SegA.lo < RectSegA.lo)
			RectSegA.lo = SegA.lo;

		if (SegA.hi > RectSegA.hi)
			RectSegA.hi = SegA.hi;

		if (SegB.lo < RectSegB.lo)
			RectSegB.lo = SegB.lo;

		if (SegB.hi > RectSegB.hi)
			RectSegB.hi = SegB.hi;
		}

	Rect.Segs.clear();
	Rect.Attrs.clear();
	Rect.Values.clear();

	RectSegA.Plus = true;
	RectSegB.Plus = (PlusCount >= MinusCount);

	Rect.Segs.push_back(RectSegA);
	Rect.Segs.push_back(RectSegB);

	Rect.Attrs.push_back(ALN_ATTR_TraceType);
	Rect.Values.push_back(TraceType_BoundRect);
	}
