#ifndef	CHRNAMEINDEX_H
#define CHRNAMEINDEX_H

#include <stdio.h>
#include <algorithm>
#include <string>
#include <assert.h>
#include <map>
#include "myunistd.h"
#include "types.h"

const unsigned ChrNameIndexMagic = 0xae1111;

class ChrNameIndex
	{
public:
	void FromFile(FILE *f, bool EatStartPos = false);
	void ToFile(FILE *f);
	void Add(unsigned ChrIndex, const char *Name);
	unsigned Add(const char *Name);
	const char *GetName(unsigned ChrIndex) const;
	bool GetIndex(const char *Name, unsigned *ptrChrIndex) const;
	const std::string &GetNameString(unsigned ChrIndex) const;
	unsigned GetFirstChrIndex() const;
	unsigned GetNextChrIndex(unsigned ChrIndex) const;
	unsigned GetChrCount() const
		{
		return (unsigned) m_Indexes.size();
		}
	void clear()
		{
		m_Indexes.clear();
		m_Names.clear();
		}
	unsigned size() const
		{
		assert(m_Indexes.size() == m_Names.size());
		return (unsigned) m_Indexes.size();
		}
	void LogMe() const;

private:
	std::map<std::string, unsigned> m_Indexes;
	std::map<unsigned, std::string> m_Names;
	};

#endif // CHRNAMEINDEX_H
