#ifndef codon_h
#define codon_h

using namespace std;

enum CODON
	{
	CODON_Ala,	// A
	CODON_Cys,	// C
	CODON_Asp,	// D
	CODON_Glu,	// E
	CODON_Phe,	// F
	CODON_Gly,	// G
	CODON_His,	// H
	CODON_Ile,	// I
	CODON_Lys,	// K
	CODON_Leu,	// L
	CODON_Asn,	// N
	CODON_Met,	// M
	CODON_Pro,	// P
	CODON_Gln,	// Q
	CODON_Arg,	// R
	CODON_Ser,	// S
	CODON_Thr,	// T
	CODON_Val,	// V
	CODON_Trp,	// W
	CODON_Tyr,	// Y
	CODON_STP,
	CODON_Invalid
	};

struct CodonInfo
	{
	gpos_t Pos[3];
	string Letters;
	bool Strand;

	CodonInfo()
		{
		Clear();
		}

	void Clear()
		{
		Pos[0] = GPOS_T_MAX;
		Pos[1] = GPOS_T_MAX;
		Pos[2] = GPOS_T_MAX;
		Letters = "???";
		Strand = false;
		}

	void LogMe(bool NL = false) const
		{
		for (unsigned i = 0; i < 3; ++i)
			Log("%"PF"(%c)", Pos[i], Letters[i]);
		Log("%c", tof(Strand));
		if (NL)
			Log("\n");
		}
	};

CODON LettersToCodon(char c1, char c2, char c3);
char LettersToCodonChar(char c1, char c2, char c3);
unsigned CharsToAminoIndex(char c1, char c2, char c3);
CODON AminoCharToCodon(char c);
char CodonToAminoChar(CODON c);
bool Is4D(char a1, char a2, char b1, char b2);

#endif // codon_h
