#include "utils.h"
#include "intlist.h"

void ColToSeq(const IntVec &Cols, const std::string &Path, IntVec &SeqPos1,
  IntVec &SeqPos2)
	{
	SeqPos1.clear();
	SeqPos2.clear();

	unsigned Pos1 = 0;
	unsigned Pos2 = 0;

	unsigned ColPosCount = (unsigned) Cols.size();
	if (ColPosCount == 0)
		return;

	unsigned ColPos = 0;
	unsigned AlnLength = (unsigned) Path.size();
	for (unsigned Col = 0; Col < AlnLength; ++Col)
		{
		if (Col == Cols[ColPos])
			{
			SeqPos1.push_back(Pos1);
			SeqPos2.push_back(Pos2);
			if (ColPos == ColPosCount - 1)
				return;
			if (Cols[ColPos] >= Cols[ColPos+1])
				Die("ColToSeq: Cols not sorted");
			++ColPos;
			}

		char Edge = Path[Col];
		switch (Edge)
			{
		case 'M':
			++Pos1;
			++Pos2;
			break;
		case 'D':
			++Pos1;
			break;
		case 'I':
			++Pos2;
			break;
		default:
			assert(false);
			}
		}
	}
