#include "utils.h"
#include "revfile.h"
#include "getopts.h"

void LogAIRows(const AlnInfo &AI, const StdStrVec &Rows, const RevFile *Rev = 0);

void DumpAI()
	{
	const char *FileName = RequiredValueOpt("dumpai");
	unsigned AIIndex = RequiredIntOpt("aiindex");

	RevFile Rev;
	Rev.Open(FileName);

	AlnInfo AI;
	unsigned AlnIndex = Rev.GetAlnInfo(AIIndex, AI);
	Dump("\n");
	Dump("AIIndex = %u\n", AIIndex);
	LogAIN(AI);

	if (AlnIndex == UINT_MAX)
		return;

	Dump("\n");
	Dump("AlnIndex = %u\n", AlnIndex);
	StdStrVec Rows;
	Rev.GetAlnRows(AlnIndex, Rows);
	LogAIRows(AI, Rows, &Rev);
	}
