#include "revfile.h"
#include "utils.h"
#include "getopts.h"

void DumpChrIds()
	{
	const char *InFileName = RequiredValueOpt("dumpchrids");

	RevFile In;
	In.Open(InFileName);

	const unsigned GenCount = In.GetGenomeCount();
	for (unsigned GenIndex = 0; GenIndex < GenCount; ++GenIndex)
		{
		const std::string &GenName = In.GetGenomeName(GenIndex);
		Dump("\n");
		Dump("\n");
		Dump("Genome %s\n", GenName.c_str());

		const GenInfo &GI = In.GetGenomeInfo(GenIndex);
		const unsigned ChrCount = GI.GetChrCount();

		Dump("%u chrs\n", ChrCount);
		Dump("\n");

		Dump("Index     Id      Length  Name\n");
		Dump("=====  =====  ==========  ====\n");
		for (unsigned ChrIndex = 0; ChrIndex < ChrCount; ++ChrIndex)
			{
			const ChrInfo &CI = GI.GetChrInfoByIndex(ChrIndex);
			const std::string &ChrName = CI.GetName();
			coord_t ChrLength = CI.GetLength();
			unsigned ChrId = CI.GetId();

			Dump("%5u  %5u  %10u  %s\n", ChrIndex, ChrId, ChrLength, ChrName.c_str());
			}
		}
	}
