#include "utils.h"
#include "progress.h"
#include "getopts.h"

void Evolve();
void InterChr();

void FindNs();
void GenerateNCCEs();
void AssignNCCEs();
void AssignProbs();
void SizeOf();
void LogModel();
void ValGenes();
void CvtAnnots();
void CpGDist();
void ProbStats();
void AlnStats();
void AnnotStats();
void CDSAlns();
void GetProteins();
void MergeChrs();
void DumpEvo();
void FindORFs();
void XlatSeq();
void TruncNorm();
void AncStats();
void ShowCompost();
void GetCodonSubs();

void TestRand();
void TestMicro();
void TestICE();
void TestEvent();
void TestGeneDupe();
void TestInterChrGeneDupe();
void TruncMeanTable();
void FixCpGs();
void XGFF();
void XferAnnots();
void DeleteRandGenes();

void Test()
	{
	void TestRand();
	TestRand();
	}

static void Credits()
	{
	fprintf(stderr, "\n");
#if	DEBUG
	fprintf(stderr, "EVOLVER v1.0-DEBUG by Robert C. Edgar\n");
#else
	fprintf(stderr, "EVOLVER v1.0r by Robert C. Edgar\n");
#endif
	fprintf(stderr, "This software is donated to the public domain.\n");
	fprintf(stderr, "Please visit web site for requested citation.\n");
	fprintf(stderr, "http://www.drive5.com/evolver\n");
	fprintf(stderr, "\n");
	}

int g_EvoMainResult = 0;

int main(int argc, char **argv)
	{
	ProcessArgVect(argc, argv);
	Credits();

	//try
	//	{
	if (0)
		;
	else if (FlagOpt("testrand"))
		TestRand();
	else if (FlagOpt("testmicro"))
		TestMicro();
	else if (FlagOpt("testice"))
		TestICE();
	else if (ValueOpt("findns"))
		FindNs();
	else if (FlagOpt("logmodel") && !ValueOpt("inseq"))
	{
		SetLogProgress(false);
		LogModel();
	}
	else if (FlagOpt("genncces"))
		GenerateNCCEs();
	else if (ValueOpt("assncces"))
		AssignNCCEs();
	else if (ValueOpt("assprobs"))
		AssignProbs();
	else if (FlagOpt("sizeof"))
		SizeOf();
	else if (ValueOpt("interchr"))
		InterChr();
	else if (ValueOpt("valgenes"))
		ValGenes();
	else if (ValueOpt("cvtannots"))
		CvtAnnots();
	else if (ValueOpt("testevent"))
		TestEvent();
	else if (FlagOpt("testgenedupe"))
		TestGeneDupe();
	else if (ValueOpt("testicgenedupe"))
		TestInterChrGeneDupe();
	else if (FlagOpt("truncmeantable"))
		TruncMeanTable();
	else if (ValueOpt("cpgdist"))
		CpGDist();
	else if (ValueOpt("probstats"))
		ProbStats();
	else if (ValueOpt("alnstats"))
		AlnStats();
	else if (ValueOpt("cdsalns"))
		CDSAlns();
	else if (ValueOpt("annotstats"))
		AnnotStats();
	else if (ValueOpt("fixcpgs"))
		FixCpGs();
	else if (ValueOpt("getprots"))
		GetProteins();
	else if (ValueOpt("xgff"))
		XGFF();
	else if (ValueOpt("xferannots"))
		XferAnnots();
	else if (ValueOpt("mergechrs"))
		MergeChrs();
	else if (ValueOpt("getcodonsubs"))
		GetCodonSubs();
	else if (ValueOpt("dumpevo"))
		DumpEvo();
	else if (ValueOpt("findorfs"))
		FindORFs();
	else if (ValueOpt("xlatseq"))
		XlatSeq();
	else if (ValueOpt("delrandgenes"))
		DeleteRandGenes();
	else if (ValueOpt("truncnorm"))
		TruncNorm();
	else if (FlagOpt("test"))
		Test();
	else if (ValueOpt("inseq") || ValueOpt("inevo"))
		Evolve();
	else if (ValueOpt("ancstats"))
		{
		SetLogProgress(false);
		AncStats();
		}
	else if (ValueOpt("compost1") && ValueOpt("compost2"))
		{
		SetLogProgress(false);
		ShowCompost();
		}
	else
		Usage();

	ProgressExit();
	//	}
	//catch (...)
	//	{
	//	fprintf(stderr, "\n*** EXCEPTION CAUGHT\n");
	//	Die("Exception caught");
	//	}
	return g_EvoMainResult;
	}
