#include "evolver.h"
#include "revfile.h"

void Evolver::FromRevFile(const RevFile &Rev, unsigned GenomeIndex,
  unsigned ChrId, bool ShowProgress)
	{
	coord_t SeqLength = Rev.GetSeqLength(GenomeIndex, ChrId);
	char *Seq = (char *) malloc(SeqLength);
	if (Seq == 0)
		Die("Out of memory allocating input sequence (%"COORD_T_PRINTF" bytes)",
		  SeqLength);

	Rev.GetSeq(GenomeIndex, ChrId, Seq, SeqLength);
	FromCString(Seq, SeqLength, ShowProgress);

	m_AncGenInfo = Rev.GetGenomeInfo(GenomeIndex);
	m_AncChrId = ChrId;

	free(Seq);
	}
