#include "evolver.h"
#include "myrand.h"

const unsigned RandSeqLength = 10*1000*1000;

void SizeOf()
	{
	Dump("int          %u\n", (unsigned) sizeof(int));
	Dump("void *       %u\n", (unsigned) sizeof(void *));
	Dump("uint32       %u\n", (unsigned) sizeof(uint32));

	Evolver Evo;
	string Seq;
	double Mem0 = GetMemUseBytes();
	RandSeq(Seq, RandSeqLength);
	double Mem1 = GetMemUseBytes();
	Evo.FromString(Seq);
	double  Mem2 = GetMemUseBytes();
	Seq.clear();
	double  Mem3 = GetMemUseBytes();

	double  Mem = (Mem2 - Mem1);
	double MemPerBase = (double) Mem/ (double) RandSeqLength;

	Evo.SetTandemMotifLength(0, 999999, 1);

	double Mem4 = GetMemUseBytes();
	Mem = Mem4 - Mem3;
	unsigned MinBytesPerBase = (unsigned) (sizeof(BaseInfo) + 2*sizeof(uint32));

	Dump("Mem0         %.1f Mb\n", Mem0/1e6);
	Dump("Mem1         %.1f Mb\n", Mem1/1e6);
	Dump("Mem2         %.1f Mb\n", Mem2/1e6);
	Dump("Mem3         %.1f Mb\n", Mem3/1e6);
	Dump("\n");
	Dump("Base         %u\n", (unsigned) sizeof(BaseInfo));
	Dump("Minimum      %u bytes/base  \n", MinBytesPerBase);
	Dump("Measured     %.1f bytes/base\n", MemPerBase);
	Dump("Measured     %.1f bytes/tan base\n", Mem/1e6);
	}
