#ifndef	genncce_h
#define	genncce_h

#ifdef _MSC_VER
#define _USE_MATH_DEFINES // required by MSC to get M_PI
#endif

#include <math.h>
#include "lohi.h"

#ifndef M_PI
#define M_PI	((double) 3.14159265358979323846)
#endif

enum CE_SPEED
	{
	CES_Slow,
	CES_Medium,
	CES_Fast,
	};

struct GeneData
	{
	unsigned Index;
	gpos_t lo;
	gpos_t hi;
	gpos_t ExtendedLo;
	gpos_t ExtendedHi;
	CE_SPEED Speed;

	GeneData()
		{
		Index = UINT_MAX;
		lo = GPOS_T_MAX;
		hi = GPOS_T_MAX;
		ExtendedLo = GPOS_T_MAX;
		ExtendedHi = GPOS_T_MAX;
		Speed = (CE_SPEED) INT_MAX;
		}

	bool operator<(const GeneData &rhs) const
		{
		return lo < rhs.lo;
		}

	void LogMe(bool NL = false) const
		{
		Log("Ix=%u Lo=%"PF" Hi=%"PF" ExLo=%"PF" ExHi=%"PF" Speed=%d",
		  Index, lo, hi, ExtendedLo, ExtendedHi, (int) Speed);
		if (NL)
			Log("\n");
		}
	};

const char *GeneSpeedToStr(CE_SPEED Speed);

#endif // genncce_h
