#include "revfile.h"

coord_t GetOverlapLength(coord_t loA, coord_t hiA, coord_t loB, coord_t hiB);

unsigned GetOverlappingSegIndex(const AlnInfo &AI, unsigned GenomeIndex,
  unsigned ChrId, coord_t lo, coord_t hi)
	{
	const GCSegVec &Segs = AI.Segs;
	const unsigned SegCount = AI.GetSegCount();
	for (unsigned SegIndex = 0; SegIndex < SegCount; ++SegIndex)
		{
		const GCSeg &Seg = Segs[SegIndex];
		if (Seg.GenomeIndex != GenomeIndex || Seg.ChrId != ChrId)
			continue;
		if (GetOverlapLength(lo, hi, Seg.lo, Seg.hi) > 0)
			return SegIndex;
		}
	return UINT_MAX;
	}
