#include "revfile.h"
#include "utils.h"

void LogBP(const AIBP &BP)
	{
	Log("Pos=%7d  AI=%5d  Seg=%2u %s",
	  BP.Pos,
	  BP.AlnInfoIndex,
	  BP.SegIndex,
	  BP.IsLo ? "Lo" : "Hi");
	}

void LogAIBPs(const AIBPVec &BPs)
	{
	unsigned BPCount = (unsigned) BPs.size();
	Log("%lu BPs\n", BPCount);
	Log("\n");
	Log("       Pos  ChrId  lh   SegIx     AIIndex\n");
	Log("==========  =====  ==  ======  ==========\n");
	for (unsigned BPIndex = 0; BPIndex < BPCount; ++BPIndex)
		{
		const AIBP &BP = BPs[BPIndex];
		Log("%10u  %5u  %2s  %6u  %10u\n",
		  (unsigned) BP.Pos,
		  BP.ChrId,
		  BP.IsLo ? "lo" : "hi",
		  BP.SegIndex,
		  BP.AlnInfoIndex);
		}
	Log("\n");
	}
