#include "intlist.h"
#include "utils.h"

void LogIntVecVec(const IntVecVec &IVV)
	{
	const unsigned N = (unsigned) IVV.size();
	Log("%u vectors\n", N);
	unsigned MaxLen = 0;
	for (unsigned i = 0; i < N; ++i)
		{
		unsigned L = (unsigned) IVV[i].size();
		if (L > MaxLen)
			MaxLen = L;
		}

	Log("        ");
	for (unsigned i = 0; i < MaxLen; ++i)
		Log("%6u", i);
	Log("\n");

	Log("        ");
	for (unsigned i = 0; i < MaxLen; ++i)
		Log("  ----", i);
	Log("\n");

	for (unsigned i = 0; i < N; ++i)
		{
		Log("[%5u] ", i);
		const IntVec &IV = IVV[i];
		for_CIntVec(IV, p)
			{
			unsigned k = *p;
			if (k == UINT_MAX)
				Log("     *");
			else
				Log("%6u", k);
			}
		Log("\n");
		}
	Log("\n");
	}
