#ifndef MASKTAB_H
#define MASKTAB_H

#include "xlat.h"

const unsigned MaskTableMagic = 0x3a582;

struct MaskTableHdr
	{
	unsigned Magic;
	unsigned WordSize;
	ALPHA Alpha;
	};

class MaskTable
	{
public:
	MaskTable();
	void Free();
	void Init(ALPHA Alpha, unsigned WordSize);
	void SetBit(uint64 i);
	bool GetBit(uint64 i) const;
	void ToFile(const char *FileName) const;
	void FromFile(const char *FileName);
	ALPHA GetAlpha() const { return m_Alpha; }
	unsigned GetWordSize() const { return m_WordSize; }
	uint64 BitVectorBytes() const;

private:
// Bit vector
	unsigned char *m_BitVector;
	uint64 m_WordCount;
	unsigned m_WordSize;
	ALPHA m_Alpha;
	};

#endif //  MASKTAB_H
