#ifndef myrand_h
#define myrand_h

#define TRACERAND	0

#include "types.h"
#include <vector>
#include <stdio.h>

using namespace std;

void RandBuffer(unsigned char Buffer[], unsigned Bytes);
bool RandTrue(double Prob);
void SetWeightVec(const vector<double> &Weights, vector<unsigned> &WeightVec,
  unsigned TargetLength);
void GetWeightsFromWeightVec(const vector<unsigned> &WeightVec,
  vector<double> &Weights);
coord_t RandCoord(coord_t N);
gpos_t RandPos(gpos_t N);
uint32 RandInt32();
void InitRand();
void InitRand(uint32 Seed);
unsigned RandInt(unsigned N);
uint64 RandInt64(uint64 N);
double RandExp(double m);
char RandLetter();
void RandSeq(string &Seq, unsigned Length);
unsigned WeightedRand(const vector<unsigned> &WeightVec);
unsigned RandWeightDist(const double Weights[], unsigned N);
unsigned RandWeightDist(const vector<double> &Weights);
unsigned RandWeightDist4(const vector<unsigned> &His);
void RandomizeVec(vector<unsigned> &Vec);
void RandomizeVec(vector<double> &Vec);
void RandomizeVecWeighted(vector<unsigned> &Vec, const vector<double> &Weights);
void GetRandDistHis(const vector<double> &Weights, vector<unsigned> &His);
double RandNorm(double Mean, double StdDev);
void WriteRandState(FILE *f);
void ReadRandState(FILE *f);
void LogRandState();
unsigned GetStochasticSeed();

unsigned RandInt_Trace(const char *FileName, int LineNr, unsigned N);
uint64 RandInt64_Trace(const char *FileName, int LineNr, uint64 N);
double RandExp_Trace(const char *FileName, int LineNr, double m);
bool RandTrue_Trace(const char *FileName, int LineNr, double Prob);

#if	TRACERAND
#define RandInt(N)		RandInt_Trace(__FILE__, __LINE__, N)
#define RandInt64(N)	RandInt64_Trace(__FILE__, __LINE__, N)
#define RandExp(m)		RandExp_Trace(__FILE__, __LINE__, m)
#define RandTrue(p)		RandTrue_Trace(__FILE__, __LINE__, p)
#endif

#endif // myrand_h
