#include "align4.h"

void OutputPairwiseAln(RevFile &Out, const RevFile &SeqRevFileA,
  const RevFile &SeqRevFileB, const AlnInfo &UserAI, const StdStr &Path)
	{
	unsigned GenomeIndexA = GetFilterGenomeIndexA();
	unsigned GenomeIndexB = GetFilterGenomeIndexB();

	unsigned ChrIdA = GetFilterChrIdA();
	unsigned ChrIdB = GetFilterChrIdB();

	const GCSeg &UserSegA = UserAI.GetSeg(GenomeIndexA);
	const GCSeg &UserSegB = UserAI.GetSeg(GenomeIndexB);

	unsigned LengthA = UserSegA.GetLength();
	unsigned LengthB = UserSegB.GetLength();

	char *UserSeqA = myalloc(char, LengthA);
	char *UserSeqB = myalloc(char, LengthB);
	
	coord_t PosA = UserSegA.lo;
	coord_t PosB = UserSegB.lo;

	bool Plus = (UserSegA.Plus == UserSegB.Plus);

	FilterAwareGetSeqData(SeqRevFileA, GenomeIndexA, ChrIdA, PosA, LengthA,
	  UserSeqA, true);

	FilterAwareGetSeqData(SeqRevFileB, GenomeIndexB, ChrIdB, PosB, LengthB,
	  UserSeqB, Plus);

	StdStrVec UserRows;
	UserRows.resize(2);
	MakeAln(UserSeqA, LengthA, UserSeqB, LengthB, Path, UserRows[0], UserRows[1]);

	FilterAwareOutputAlnRows(Out, UserAI, UserRows);

	myfree(UserSeqA);
	myfree(UserSeqB);
	}
