#include <string>
#include "utils.h"
#include "base.h"

unsigned char CompMap[256];
byte CharToBitLetterMap[256];
char BitLetterToCharMap[8];

static bool InitMap()
	{
	for (unsigned i = 0; i < 256; ++i)
		CharToBitLetterMap[i] = BIT_LETTER_INVALID;

	CharToBitLetterMap[(int) 'a'] = BIT_LETTER_A;
	CharToBitLetterMap[(int) 'c'] = BIT_LETTER_C;
	CharToBitLetterMap[(int) 'g'] = BIT_LETTER_G;
	CharToBitLetterMap[(int) 't'] = BIT_LETTER_T;

	CharToBitLetterMap[(int) 'A'] = BIT_LETTER_A;
	CharToBitLetterMap[(int) 'C'] = BIT_LETTER_C;
	CharToBitLetterMap[(int) 'G'] = BIT_LETTER_G;
	CharToBitLetterMap[(int) 'T'] = BIT_LETTER_T;

	CharToBitLetterMap[(int) '-'] = BIT_LETTER_GAP;

	BitLetterToCharMap[BIT_LETTER_A] = 'A';
	BitLetterToCharMap[BIT_LETTER_C] = 'C';
	BitLetterToCharMap[BIT_LETTER_G] = 'G';
	BitLetterToCharMap[BIT_LETTER_T] = 'T';
	BitLetterToCharMap[BIT_LETTER_GAP] = '-';
	BitLetterToCharMap[BIT_LETTER_INVALID] = '?';

	for (unsigned i = 0; i < 256; ++i)
		CompMap[i] = (unsigned char) i;

	CompMap[(int) 'a'] = 't';
	CompMap[(int) 'c'] = 'g';
	CompMap[(int) 'g'] = 'c';
	CompMap[(int) 't'] = 'a';

	CompMap[(int) 'A'] = 'T';
	CompMap[(int) 'C'] = 'G';
	CompMap[(int) 'G'] = 'C';
	CompMap[(int) 'T'] = 'A';

	CompMap[(int) '-'] = '-';
	return true;
	}
static bool InitDone = InitMap();

char BitLetterToChar(byte BitLetter)
	{
	return BitLetterToCharMap[BitLetter];
	}

byte CharToBitLetter(char Letter)
	{
	return CharToBitLetterMap[(unsigned char) Letter];
	}

char CompLetter(char c)
	{
	return CompMap[(unsigned char) c];
	}

void RevComp(char *S, unsigned L)
	{
	unsigned char *s = (unsigned char *) S;
	unsigned char *t = (unsigned char *) (S + L - 1);
	while (s < t)
		{	
		unsigned char c = *s;
		*s++ = CompMap[*t];
		*t-- = CompMap[c];
		}
	if (s == t)
		*s = CompMap[*s];
	}

void RevComp(const std::string &Seq, std::string &RevCompSeq)
	{
	if (&Seq == &RevCompSeq)
		{
		void RevComp(std::string &Seq);
		RevComp(RevCompSeq);
		return;
		}

	unsigned Length = (unsigned) Seq.size();
	RevCompSeq.resize(Length);
	for (unsigned i = 0; i < Length; ++i)
		{
		unsigned char c = (unsigned char) Seq[i];
		RevCompSeq[Length - i - 1] = CompMap[c];
		}
	}

void RevComp(std::string &Seq)
	{
	std::string RevCompSeq;
	RevComp(Seq, RevCompSeq);
	Seq = RevCompSeq;
	}
