#include <string>
#include "utils.h"
#include "evomodel.h"

using namespace std;

const string *g_Name;
const string *g_Value;

static double StrToFlt(const string &Str, double Min, double Max)
	{
	double d = atof(Str.c_str());
	if (d < Min || d > Max)
		Die("Parameter %s=%s out of range, min=%g max=%g",
		  g_Name->c_str(), Str.c_str(), Min, Max);
	return d;
	}

static unsigned StrToPos(const string &Str, gpos_t Min, gpos_t Max)
	{
	char *NotUsed;
	gpos_t d = strtoul(Str.c_str(), &NotUsed, 10);
	if (d < Min || d > Max)
		Die("Parameter %s=%s out of range, min=%u max=%u",
		  g_Name->c_str(), Str.c_str(), Min, Max);
	return d;
	}

void SetEvoParam(const string &Name, const string &Value_)
	{
	string Value(Value_);

	g_Name = &Name;
	g_Value = &Value;

#define POS(x, v, min, max)	else if (Name == #x) P_##x = StrToPos(Value, min, max);
#define FLT(x, v, min, max)	else if (Name == #x) P_##x = StrToFlt(Value, min, max);

	if (0) ;
#include "evoscalarparams.h"
	else
		Die("Unknown parameter in model file: %s", Name.c_str());
	}
