#include "utils.h"
#include "getopts.h"
#include <string.h>
#include <string>

static const char *g_TruncLabel;
static bool g_First = true;

const char *TruncLabel(const char *Label)
	{
	if (g_First)
		{
		g_First = false;
		g_TruncLabel = ValueOpt("trunclabel");
		}

	static char *Buffer = 0;
	if (Buffer != 0)
		{
		free(Buffer);
		Buffer = 0;
		}

	if (g_TruncLabel == 0)
		return Label;

	const char *p = strstr(Label, g_TruncLabel);
	if (p == 0)
		return Label;

	Buffer = strsave(Label);
	Buffer[p - Label] = 0;
	return Buffer;
	}

void TruncLabel(std::string &Label)
	{
	Label = TruncLabel(Label.c_str());
	}
