#include "utils.h"
#include "revfile.h"

void TruncLabel(std::string &Label);

void TruncLabelGenome(GenInfo &Genome)
	{
	std::string Name = Genome.GetName();
	TruncLabel(Name);
	Genome.SetName(Name);

	const unsigned ChrCount = Genome.GetChrCount();
	for (unsigned ChrIndex = 0; ChrIndex < ChrCount; ++ChrIndex)
		{
		ChrInfo &CI = Genome.GetModifiableChrInfoByIndex(ChrIndex);
		std::string Name = CI.GetName();
		TruncLabel(Name);
		CI.SetName(Name);
		}
	}

void TruncLabelGenomes(std::vector<GenInfo> &Genomes)
	{
	const unsigned GenomeCount = (unsigned) Genomes.size();
	for (unsigned GenomeIndex = 0; GenomeIndex < GenomeCount; ++GenomeIndex)
		{
		GenInfo &Gen = Genomes[GenomeIndex];
		TruncLabelGenome(Gen);
		}
	}
