#include "ice.h"
#include "myrand.h"
#include "evomodel.h"

EVENT_RESULT InterChrEvolver::Try_ChrFuse()
	{
	unsigned ChrCount = GetChrCount();
	if (ChrCount <= P_MinChrCount)
		EV_REJECTN(ChrFuse, ChrCount)

	unsigned ChrIndex1 = RandInt(ChrCount);
	unsigned ChrIndex2 = RandInt(ChrCount - 1);
	if (ChrIndex2 >= ChrIndex1)
		++ChrIndex2;

	if (GetChrLength(ChrIndex1) + GetChrLength(ChrIndex2) > P_MaxChrLength)
		EV_REJECTN(ChrFuse, ChrLength)

	if (m_LogEvents)
		Log("@CHRFUSE Ev %u Chrs %u %u\n",
		  m_LastAcceptedEventIndex,
		  ChrIndex1,
		  ChrIndex2);

	FuseChrs(ChrIndex1, ChrIndex2);
	EV_ACCEPTN(ChrFuse, 0)
	}
