#include "ice.h"
#include "evomodel.h"
#include "ratemgr.h"

EVENT_RESULT InterChrEvolver::Try_ChrSplit()
	{
	if (GetChrCount() >= P_MaxChrCount)
		EV_REJECTN(ChrSplit, ChrCount)

	unsigned ChrIndex;
	gpos_t Pos;
	GetRandomPos(ChrIndex, Pos);
	m_CurrentEventPos = Pos;

	gpos_t Length1;
	gpos_t Length2;
	GetChrParts(ChrIndex, Pos, Length1, Length2);
	if (Length1 < P_MinChrLength || Length2 < P_MinChrLength)
		EV_REJECTN(ChrSplit, ChrLength)

	if (PosInGene(ChrIndex, Pos) || PosIsConstrained(ChrIndex, Pos))
		EV_REJECTN(ChrSplit, InGene)

// 1Mb arbitrary choice
	bool Accept = AcceptInsert(ChrIndex, Pos, 1000000);
	if (!Accept)
		EV_REJECTN(ChrSplit, Insert)

	if (m_LogEvents)
		Log("@CHRSPLIT Ev %u Chr %u Pos %"PF"\n",
		  m_LastAcceptedEventIndex,
		  ChrIndex,
		  Pos);

	SplitChr(ChrIndex, Pos);
	EV_ACCEPTN(ChrSplit, Pos);
	}
