#include "evolver.h"
#include "eventresult.h"
#include "ratemgr.h"
#include "evomodel.h"
#include "myrand.h"

// TODO: copy m_Tandems, also tandem..

extern unsigned g_TotalCopyCount;
extern unsigned g_InvertableCopyCount;
extern unsigned g_InvertedCopyCount;

EVENT_RESULT Evolver::Try_Copy()
	{
	gpos_t FromPos = GetRandomPos();
	if (FromPos == GPOS_T_MAX)
		EV_FAIL(Copy, 0, GetRandomPos)

	EV_GETLENGTH(Copy, CopyLength)
	gpos_t ToPos = GetRandomPos();
	if (ToPos == GPOS_T_MAX)
		EV_FAIL(Copy, CopyLength, GetRandomPos)

	if (!RangeExists(FromPos, CopyLength) || !RangeExists(ToPos, 2))
		EV_FAIL(Copy, CopyLength, RangeExists)

	if (PosInRange(ToPos, FromPos, CopyLength))
		EV_FAIL(Copy, CopyLength, PosInRange)

	m_CurrentEventPos = FromPos;
	string Seq;
	GetSubSeq(FromPos, CopyLength, Seq);

	bool DoInvert = false;
	if (CopyLength >= P_MinCopyInvertLength)
		DoInvert = RandTrue(P_CopyInvertProb);

	if (DoInvert)
		{
		void RevComp(string &Seq);
		RevComp(Seq);
		}

	//bool Accept = AcceptInsert(ToPos, Seq);
	//if (!Accept)
	//	EV_REJECT(Copy, CopyLength, Copy)
	ACCEPT_INSERT(Copy, ToPos, Seq)

	if (CopyLength >= P_MinCopyInvertLength)
		++g_InvertableCopyCount;

	vector<gpos_t> GeneStarts;
	vector<gpos_t> CopiedGeneStarts;
	Copy(FromPos, ToPos, CopyLength, GeneStarts, CopiedGeneStarts, DoInvert);
	DupeGenes(GeneStarts, CopiedGeneStarts, DoInvert);

	if (DoInvert)
		{
	// Must invert in Copy so that SetInsertConstraints
	// sees the inverted bases.
		//gpos_t FirstInsertedPos = GetNextPos(ToPos);
		//Invert(FirstInsertedPos, CopyLength);
		++g_InvertedCopyCount;
		}
	++g_TotalCopyCount;

	EV_ACCEPT(Copy, ToPos, CopyLength)
	}
