#include "utils.h"
#include "evomodel.h"
#include "evolver.h"
#include "myrand.h"

EVENT_RESULT Evolver::Try_CreateIsland()
	{
	vector<gpos_t> IslandStarts;
	vector<gpos_t> IslandLengths;
	GetIslands(m_FirstEvolvedPos, UINT32_MAX, IslandStarts, IslandLengths);
	unsigned NIsland = SIZE(IslandStarts);
	asserta(SIZE(IslandLengths) == NIsland);
	if (NIsland == 0)
		EV_FAILN(CreateIsland, NoIslands);

// "Ocean" is region where a new island can be put
	vector<gpos_t> OceanStarts;
	vector<gpos_t> OceanLengths;
	GetOceans(m_FirstEvolvedPos, UINT32_MAX, OceanStarts, OceanLengths);

	unsigned NOceans = SIZE(OceanStarts); 
	asserta(SIZE(OceanLengths) == NOceans);

	gpos_t IslandStart = GPOS_T_MAX;
	gpos_t IslandLength = GPOS_T_MAX;
	gpos_t OceanStart = GPOS_T_MAX;
	gpos_t OceanLength = GPOS_T_MAX;
	for (unsigned Try = 0; ; ++Try)
		{
		if (Try >= 100)
			EV_FAILN(CreateIsland, MaxTries)

		unsigned rIsland = RandInt(SIZE(IslandStarts));
		IslandStart = IslandStarts[rIsland];
		IslandLength = IslandLengths[rIsland];

		vector<gpos_t> CandStarts;
		vector<gpos_t> CandLengths;
		vector<double> CandWeights;
		gpos_t MinCandLength = IslandLength;
		for (unsigned i = 0; i < NOceans; ++i)
			{
			if (OceanLengths[i] > MinCandLength)
				{
				CandStarts.push_back(OceanStarts[i]);
				CandLengths.push_back(OceanLengths[i]);
				CandWeights.push_back(OceanLengths[i]);
				}
			}
		if (!CandStarts.empty())
			{
			unsigned rOcean = RandWeightDist(CandWeights);
			OceanStart = CandStarts[rOcean];
			OceanLength = CandLengths[rOcean];
			break;
			}
		}

	asserta(OceanLength > IslandLength);
	gpos_t Offset = RandInt(OceanLength - IslandLength);

	gpos_t Pos = OceanStart;
	m_CurrentEventPos = Pos;
	for (gpos_t i = 0; i < Offset; ++i)
		{
		const BaseInfo &Base = GetBase(Pos);
		asserta(Base.IsOcean());
		Pos = GetNextPos(Pos);
		}

	gpos_t NewIslandStartPos = Pos;
	for (gpos_t i = 0; i < IslandLength; ++i)
		{
		BaseInfo &Base = GetBase(Pos);
		asserta(Base.IsOcean());
		Base.SetIsland(true);
		Pos = GetNextPos(Pos);
		}

	EV_ACCEPTN(CreateIsland, NewIslandStartPos);
	}
