#include "utils.h"
#include "evolver.h"
#include "myrand.h"

EVENT_RESULT Evolver::Try_DeleteNGE()
	{
	vector<gpos_t> Starts;
	vector<gpos_t> Lengths;
	vector<double> MACs;
	GetNGEs(Starts, Lengths, MACs);
	unsigned N = SIZE(Starts);
	asserta(SIZE(Lengths) == N);
	asserta(SIZE(MACs) == N);
	if (N == 0)
		EV_FAILN(DeleteNGE, NoNGEs);

	unsigned r = RandWeightDist(MACs);
	gpos_t Length = Lengths[r];
	gpos_t Pos = Starts[r];
	m_CurrentEventPos = Pos;
	for (gpos_t i = 0; i < Length; ++i)
		{
		BaseInfo &Base = GetBase(Pos);
		Base.Deconstrain();
		Pos = GetNextPos(Pos);
		}

	EV_ACCEPTN(DeleteNGE, Pos);
	}
