#include "evolver.h"
#include "myrand.h"

void Evolver::GetGeneWeightVec(const vector<GeneInfo> &Genes,
  vector<double> &MACs) const
	{
	const unsigned GeneCount = SIZE(Genes);
	MACs.resize(GeneCount);
	for (unsigned i = 0; i < GeneCount; ++i)
		{
		const GeneInfo &Gene = Genes[i];
		MACs[i] = Gene.MeanAccProb;
		}
	}

void Evolver::InitTryGenes(vector<GeneInfo> &Genes, vector<double> &MACs) const
	{
	GetGenes(Genes);
	GetGeneWeightVec(Genes, MACs);
	}

bool Evolver::NextTryGene(vector<GeneInfo> &Genes, vector<double> &MACs,
  GeneInfo &Gene) const
	{
	asserta(SIZE(Genes) == SIZE(MACs));

	if (Genes.empty())
		return false;

	unsigned i = RandWeightDist(MACs);
	asserta(i < SIZE(Genes));
	Gene = Genes[i];
	asserta(MACs[i] == Gene.MeanAccProb);

	unsigned N = SIZE(MACs);

	Genes[i] = Genes[N-1];
	MACs[i] = MACs[N-1];

	Genes.resize(N-1);
	MACs.resize(N-1);

	return true;
	}
