#define TRACE	0

#include "utils.h"
#include "evomodel.h"
#include "evolver.h"
#include "myrand.h"

EVENT_RESULT Evolver::Try_MoveIsland()
	{
	vector<gpos_t> Starts;
	vector<gpos_t> Lengths;
	GetIslands(m_FirstEvolvedPos, UINT32_MAX, Starts, Lengths);
	unsigned N = SIZE(Starts);
	asserta(SIZE(Lengths) == N);
	if (N == 0)
		EV_FAILN(MoveIsland, NoIslands);

	gpos_t Length = GPOS_T_MAX;
	gpos_t StartPos = GPOS_T_MAX;
	gpos_t Dist = GPOS_T_MAX;
	bool Plus = true;
	for (unsigned Try = 0; ; ++Try)
		{
		if (Try >= 50)
			EV_FAILN(MoveIsland, MaxTries)

		unsigned r = RandInt(N);
		Length = Lengths[r];
		StartPos = Starts[r];
		Dist = (gpos_t) RandNorm(P_MoveCpGIslandMeanDist, P_MoveCpGIslandStdDevDist);
		if (Dist == 0)
			Dist = 1;
		Plus = RandTrue(0.5);
		gpos_t Pos = Plus ? GetRangeEndPos(StartPos, Length) : StartPos;
		m_CurrentEventPos = Pos;
#if	TRACE
		Log("\n");
		Log("MoveBGGE try %u StartPos %"PF" Length %"PF" Dist %"PF" %c\n",
		  Try, StartPos, Length, Dist, pom(Plus));
#endif
		for (gpos_t i = 0; i < Dist; ++i)
			{
			Pos = GetAdjPos(Pos, Plus);
			if (Pos == GPOS_T_MAX)
				goto NextTry;
			const BaseInfo &Base = GetBase(Pos);
#if	TRACE
			Log("Margin base ");
			Base.LogMe(true);
#endif
			if (!Base.IsOcean())
				goto NextTry;
			}
		break;
	NextTry:;
		}

	gpos_t NewStartPos = GPOS_T_MAX;
	if (Plus)
		NewStartPos = GetRangeEndPos(StartPos, Dist);
	else
		{
		NewStartPos = StartPos;
		for (gpos_t i = 0; i < Dist; ++i)
			NewStartPos = GetPrevPos(NewStartPos);
		}

#if	TRACE
	Log("NewStartPos %"PF"\n", NewStartPos);
#endif

	SetIsland(StartPos, Length, false);
	SetIsland(NewStartPos, Length, true);

	EV_ACCEPTN(MoveIsland, StartPos)
	}
