#include "ice.h"
#include "evomodel.h"
#include "myrand.h"

EVENT_RESULT InterChrEvolver::Try_NonRecipTransloc()
	{
	if (GetChrCount() == 1)
		EV_REJECTN(NonRecipTransloc, ChrCount);

	gpos_t FromPos;
	unsigned FromChrIndex;
	GetRandomPos(FromChrIndex, FromPos);
	m_CurrentEventPos = FromPos;
	if (PosIsConstrained(FromChrIndex, FromPos) || PosInGene(FromChrIndex, FromPos))
		EV_REJECTN(NonRecipTransloc, PosInGene)

// 1Mb arbitrary choice
	bool Accept = AcceptInsert(FromChrIndex, FromPos, 1000000);
	if (!Accept)
		EV_REJECTN(ChrSplit, Insert)

	gpos_t FromChrLength = GetChrLength(FromChrIndex);
	if (FromPos < FromChrLength/10 || FromPos > (9*FromChrLength)/10)
		EV_FAILN(NonRecipTransloc, MinL)

	gpos_t EndPos = FromChrLength - 1;
	if (PosIsConstrained(FromChrIndex, EndPos))
		EV_REJECTN(NonRecipTransloc, PosInGene);

	const unsigned ChrCount = GetChrCount();
	unsigned ToChrIndex = RandInt(ChrCount - 1);
	if (ToChrIndex >= FromChrIndex)
		++ToChrIndex;

	ContigSet Contigs;
	TruncateChr(FromChrIndex, FromPos, Contigs);
	AppendContigs(ToChrIndex, Contigs);
	RecomputeChrLengths();

	EV_ACCEPTN(NonRecipTransloc, FromPos)
	}
