#include "ice.h"
#include "evomodel.h"
#include "myrand.h"

EVENT_RESULT InterChrEvolver::Try_RecipTransloc()
	{
	if (GetChrCount() == 1)
		EV_REJECTN(RecipTransloc, ChrCount)

	gpos_t Pos1;
	unsigned ChrIndex1;
	GetRandomPos(ChrIndex1, Pos1);
	m_CurrentEventPos = Pos1;

	gpos_t Pos2;
	unsigned ChrIndex2;
	GetRandomPosDifferentChr(ChrIndex1, ChrIndex2, Pos2);

	gpos_t ChrLength1 = GetChrLength(ChrIndex1);
	gpos_t ChrLength2 = GetChrLength(ChrIndex2);

	if (Pos1 < ChrLength1/10 || Pos1 > (9*ChrLength1)/10 ||
	  Pos2 < ChrLength2/10 || Pos2 > (9*ChrLength2)/10)
		EV_FAILN(RecipTransloc, MinL)

	if (PosInGene(ChrIndex1, Pos1) || PosIsConstrained(ChrIndex1, Pos1))
		EV_REJECTN(RecipTransloc, PosInGene)
	if (PosInGene(ChrIndex2, Pos2) || PosIsConstrained(ChrIndex2, Pos2))
		EV_REJECTN(RecipTransloc, PosInGene)

	gpos_t L1 = GetChrLength(ChrIndex1) - Pos1 - 1;
	gpos_t L2 = GetChrLength(ChrIndex2) - Pos2 - 1;
	gpos_t EndPos1 = GetRangeEndPos(ChrIndex1, Pos1, L1);
	gpos_t EndPos2 = GetRangeEndPos(ChrIndex2, Pos2, L2);

	if (PosInGene(ChrIndex1, EndPos1) || PosIsConstrained(ChrIndex1, EndPos1))
		EV_REJECTN(RecipTransloc, PosInGene)
	if (PosInGene(ChrIndex2, EndPos2) || PosIsConstrained(ChrIndex2, EndPos2))
		EV_REJECTN(RecipTransloc, PosInGene)
	
	ContigSet Contigs1;
	ContigSet Contigs2;
	TruncateChr(ChrIndex1, Pos1, Contigs1);
	TruncateChr(ChrIndex2, Pos2, Contigs2);

	AppendContigs(ChrIndex1, Contigs2);
	AppendContigs(ChrIndex2, Contigs1);

	RecomputeChrLengths();

	EV_ACCEPTN(RecipTransloc, Pos1)
	}
