#ifndef UNIQUEBID_H
#define UNIQUEBID_H

struct UniqueBundleId
	{
	unsigned ChrId0;
	unsigned ChrId1;
	unsigned BundleId;

	bool operator==(const UniqueBundleId &rhs) const
		{
		return BundleId == rhs.BundleId && ChrId0 == rhs.ChrId0
		  && ChrId1 == rhs.ChrId1;
		}

	bool operator<(const UniqueBundleId &rhs) const
		{
		if (ChrId0 != rhs.ChrId0)
			return ChrId0 < rhs.ChrId0;
		if (ChrId1 != rhs.ChrId1)
			return ChrId1 < rhs.ChrId1;
		return BundleId < rhs.BundleId;
		}
	};

score_t GetBundleScore(const AlnInfo &AI);
score_t GetBundleScore(const UniqueBundleId &UBI);
void ComputeBundleScores(const AIVec &AIs,
  std::map<UniqueBundleId, score_t> &BundleScores);
void ComputeBundleLoHis(const AIVec &AIs, unsigned GenomeIndex,
  std::map<UniqueBundleId, coord_t> &los, std::map<UniqueBundleId, coord_t> &his);

#endif // UNIQUEBID_H
