#include <string>
#include "revfile.h"

using namespace std;

void RevComp(const string &Seq, string &RevCompSeq);

unsigned g_ValAlnColCount;

static void ValRow(unsigned RowIndex, const GCSeg &Seg,
  const StdStr &Row, const char *Seq, coord_t SeqLength)
	{
	asserta(Seg.lo <= Seg.hi);
	asserta(Seg.hi < SeqLength);

	StdStr RowSeq;
	if (Seg.Plus)
		RowSeq = Row;
	else
		RevComp(Row, RowSeq);

	const unsigned RowLength = SIZE(Row);
	coord_t Pos = Seg.lo;
	for (unsigned Col = 0; Col < RowLength; ++Col)
		{
		char c = RowSeq[Col];
		if (c == '-')
			continue;
		++g_ValAlnColCount;
		if (toupper(c) != toupper(Seq[Pos]))
			{
			Log("\n");
			Log("Row %u seg gen %u chr %u lo %u hi %u %c\n",
			  RowIndex, Seg.GenomeIndex, Seg.ChrId, Seg.lo, Seg.hi, pom(Seg.Plus));
			Die("Pos=%"PF" Col=%u Row=%c Seq=%c",
			  Pos, Col, c, Seq[Pos]);
			}
		++Pos;
		}
	}

void ValAln(const AlnInfo &AI, const StdStrVec &Rows, const char *Seq0,
  coord_t Seq0Len, const char *Seq1, coord_t Seq1Len)
	{
	ValRow(0, AI.Segs[0], Rows[0], Seq0, Seq0Len);
	ValRow(1, AI.Segs[1], Rows[1], Seq1, Seq1Len);
	}
