#include "evo.h"

const char *CharsToAA(char c1, char c2, char c3);
char Complement(char c);

static unsigned g_From = UINT_MAX;
static unsigned g_To = UINT_MAX;
static unsigned g_Length = UINT_MAX;
static bool g_RevComp = false;

static void Xlat(const char *Str, unsigned L)
	{
	Log("\n");
	Log("       Pos  DNA   aa\n");
	Log("----------  ---  ---\n");

	if (!g_RevComp)
		{
		for (unsigned i = 0; i < L; i += 3)
			{
			char c1 = Str[i];
			char c2 = Str[i+1];
			char c3 = Str[i+2];
			const char *Codon = CharsToAA(c1, c2, c3);
			Log("%10u  %c%c%c  %s\n", g_From + i, c1, c2, c3, Codon);
			}
		}
	else
		{
		for (int i = L - 1; i >= 2; i -= 3)
			{
			char c1 = Complement(Str[i]);
			char c2 = Complement(Str[i-1]);
			char c3 = Complement(Str[i-2]);
			const char *Codon = CharsToAA(c1, c2, c3);
			Log("%10u  %c%c%c  %s\n", g_From + i - 2, c1, c2, c3, Codon);
			}
		}
	}

static void OnSeq(const string &/*Label*/, const string &Seq)
	{
	unsigned L = SIZE(Seq);
	if (L == 0)
		return;

	if (g_From == UINT_MAX)
		g_From = 0;

	if (g_To == UINT_MAX)
		g_To = L - 1;

	if (g_Length != UINT_MAX)
		g_To = g_From + g_Length - 1;

	if (g_To >= L)
		g_To = L - 1;

	g_Length = g_To - g_From + 1;

	Xlat(Seq.c_str() + g_From, g_Length);
	}

void XlatSeq()
	{
	const char *FileName = RequiredValueOpt("xlatseq");

	IntOpt("from", &g_From);
	IntOpt("to", &g_To);
	IntOpt("length", &g_Length);

	g_RevComp = FlagOpt("revcomp");

	ReadFasta(FileName, OnSeq);
	}
